import { Logger, LogLevel, RegisteredLogger } from './logger';
import { Telemetry } from './telemetry';
export declare class MastraBase {
    component: RegisteredLogger;
    logger: Logger;
    telemetry?: Telemetry;
    constructor({ component }: {
        component: RegisteredLogger;
    });
    /**
     * Set the logger for the agent
     * @param logger
     */
    __setLogger(logger: Logger): void;
    /**
     * Internal logging helper that formats and sends logs to the configured logger
     * @param level - Severity level of the log
     * @param message - Main log message
     * @param runId - Optional runId for the log
     */
    log(level: LogLevel, message: string, runId?: string): void;
    /**
     * Set the telemetry for the agent
     * @param telemetry
     */
    __setTelemetry(telemetry: Telemetry): void;
    get experimental_telemetry(): {
        tracer: import("@opentelemetry/api").Tracer;
        isEnabled: boolean;
    } | undefined;
}
