import { z } from 'zod';
import { SyncAction, SyncExecutionContext } from './types';
export declare class Sync<TId extends string, TSchemaIn extends z.ZodSchema, TSchemaOut extends z.ZodSchema, TContext extends SyncExecutionContext<TSchemaIn>> implements SyncAction<TId, TSchemaIn, TSchemaOut, TContext> {
    id: TId;
    description?: string;
    inputSchema?: TSchemaIn;
    outputSchema?: TSchemaOut;
    execute: (context: TContext) => Promise<z.infer<TSchemaOut>>;
    engine: import("..").MastraEngine | undefined;
    constructor(opts: SyncAction<TId, TSchemaIn, TSchemaOut, TContext>);
}
export declare function createSync<TId extends string, TSchemaIn extends z.ZodSchema, TSchemaOut extends z.ZodSchema, TContext extends SyncExecutionContext<TSchemaIn>>(opts: SyncAction<TId, TSchemaIn, TSchemaOut, TContext>): Sync<TId, TSchemaIn, TSchemaOut, TContext>;
